/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Fri Apr 11 06:46:20 EDT 2003
    copyright            : (C) 2003 by Gregory Alan Hildstrom
    email                : ghildstr@hotmail.com
 ***************************************************************************/



#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

#include <iostream.h>
#include <stdlib.h>
#include <fstream.h>

int main(int argc, char *argv[])
{


if(argc != 4){
	cerr << "Error: Usage: extractbytes startbyte endbyte filename\n";
	cerr << "bytes range from 0 to filelength-1 inclusive\n";
	cerr << "startbyte should be < filelength-1\n";
	cerr << "endbyte should be <= filelength-1 or 0 to use entire file\n";
	cerr << "extractbytes version April-11-2003\n\n";
	return 1;
}//end else

	unsigned int filelength;
	unsigned int buffersize = 256;
	char * buffer;
	unsigned int startbyte = atoi(argv[1]);
	unsigned int endbyte = atoi(argv[2]);
	unsigned int extractlength = endbyte+1 - startbyte;


	ifstream inputfile;

	//test to see if the input file can be opened
	inputfile.open(argv[3]);
	if(inputfile.fail()){
		cerr << "Error: Could not open input file: " << argv[3] << ".\n";
		return 1;
	}//end else
	inputfile.close();

	//open the file in binary mode
	inputfile.open(argv[3], ios::binary, ios::in);


	//get length of file
	inputfile.seekg(0, ios::end);
	filelength = inputfile.tellg();
	inputfile.seekg(0, ios::beg);

	//check our start byte for sanity
	if(startbyte >= filelength-1){
		cerr << "Error: startbyte (" << startbyte << ") should be < filelength-1 (" << filelength-1 << ")\n";
		startbyte = 0;
		endbyte++;
		extractlength = endbyte - startbyte;
	}//end if

	//check our end byte for sanity
	else if((endbyte == 0) || (endbyte > filelength-1)){
		if(endbyte > filelength-1)
			cerr << "Error: endbyte (" << endbyte << ") should be <= filelength-1 (" << filelength-1 << ")\n";
		endbyte = filelength;
		extractlength = endbyte - startbyte;
	}//end if

	//check our byte numbers for sanity
	else if(endbyte <= startbyte){
		cerr << "Error: endbyte (" << endbyte << ") should be > startbyte (" << startbyte << ")\n";
		startbyte = 0;
		endbyte = filelength;
		extractlength = endbyte - startbyte;
	}//end if
	else{
		endbyte++;
	}//end else

	//allocate memory for buffer
	buffer = new char[buffersize];

	//determine the number of buffers
	unsigned int numberofbuffers = (unsigned int)(extractlength / buffersize);

	for(unsigned int i = 0; i < numberofbuffers; i++){

		//move to the right place in the file
		inputfile.seekg(startbyte + i*buffersize);

		//read data as a block
		inputfile.read(buffer, buffersize);

		//write buffer to stdout
		cout.write(buffer,buffersize);

	}//end for

	//move to the remaining bytes after the buffers
	inputfile.seekg(startbyte + numberofbuffers*buffersize);

	//read the remaining bytes
	inputfile.read(buffer, (endbyte - (startbyte + numberofbuffers*buffersize)));

	//write the remaining stuff to stdout
	cout.write(buffer, (endbyte - (startbyte + numberofbuffers*buffersize)));



	//close input file
	inputfile.close();




  return EXIT_SUCCESS;
}
